package org.test;

import java.util.Hashtable;

import javax.jms.ObjectMessage;
import javax.jms.Session;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class MessageProducer {

    private static final String HOST_NAME = "localhost";
    private static final String PORT = "1099";
    private static final String CONNECTION_FACTORY = "ThroughputConnectionFactory";
    private static final String TOPIC_NAME = "topic/A";
    
    
    private TopicSession session = null;
    private TopicPublisher publisher = null;
    private TopicConnection connection = null;

    public static final void main(String[] args){
        try {
            MessageProducer producer = new MessageProducer();
            producer.run();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public void run()throws Exception {
        connect();
        TestObject obj = new TestObject();
        while(true){
            ObjectMessage msg = session.createObjectMessage(obj);
            publisher.publish(msg);
            System.out.println(msg);
            Thread.sleep(5);
        }
    }
    
    public void connect() throws Exception {
        Context context = getInitialContext(HOST_NAME,PORT);
        TopicConnectionFactory topicFactory = (TopicConnectionFactory) context
        .lookup(CONNECTION_FACTORY);

        connection = topicFactory.createTopicConnection();
        session = connection.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);
        Topic topic = (Topic) context.lookup(TOPIC_NAME);
        publisher = session.createPublisher(topic);
    }

    public Context getInitialContext(String host, String jnpPort)
    throws NamingException {
        Context context = null;
        Hashtable<Object, Object> jndiProps = new Hashtable<Object, Object>();

        String serverUrl = "jnp://" + host + ":" + jnpPort;

        jndiProps.put(Context.INITIAL_CONTEXT_FACTORY,
        "org.jnp.interfaces.NamingContextFactory");
        jndiProps.put(Context.URL_PKG_PREFIXES,
        "org.jboss.naming:org.jnp.interfaces");
        jndiProps.put(Context.PROVIDER_URL, serverUrl);

        context = new InitialContext(jndiProps);

        return context;
    }

}
